using System;
using System.Threading.Tasks;
using System.Linq;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Pathing;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Bots.Grind;
using Buddy.Coroutines;
using CommonBehaviors.Actions;
using Styx.TreeSharp;

namespace AzyulDDSupport
{
	public class AzyulDDSupport : HBPlugin
	{
		public override string Name { get { return "Azyul Death Handler"; } }
		public override string Author { get { return "EchoTiger"; } }
		public override Version Version { get { return new Version(2, 0); } }
		public override bool WantButton { get { return false; } }

		public override void OnEnable()
		{
			TreeHooks.Instance.InsertHook("Questbot_Main", 0,
				_deathSupportComposite ?? (_deathSupportComposite = new ActionRunCoroutine(ctx => UniversalDeathSupport())));
				
			Logging.Write(System.Windows.Media.Colors.Yellow, "[Azyul Death Handler]: v" + Version + " - Enabled");
		}

		public override void OnDisable()
		{
			TreeHooks.Instance.RemoveHook("Questbot_Main", _deathSupportComposite);
		  
			Logging.Write(System.Windows.Media.Colors.Yellow, "[Azyul Death Handler]: v" + Version + " - Disabled");
		}
		
		private Composite _deathSupportComposite;

		private async Task<bool> UniversalDeathSupport()
		{
			if (!StyxWoW.Me.IsGhost)
				return false;

			if (StyxWoW.Me.CorpseMapId == StyxWoW.Me.MapId)
				return false;


			while (StyxWoW.Me.IsValid && StyxWoW.Me.IsGhost)
			{
				//Pit of Saron Support
				if (StyxWoW.Me.CorpseMapId == 658) { 
					//This is a total hack, I know.   Will improve later.
					Logging.Write(System.Windows.Media.Colors.Yellow, "[Azyul Death Handler]: Using custom navigation for Pit of Saron.");
					if (StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) > 42000)
					{
						Flightor.MoveTo(new WoWPoint(5694.283, 2168.482, 803.9979));
					}
					if (StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) > 18250 && StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) < 42000)
					{
						Flightor.MoveTo(new WoWPoint(5686.418, 2105.479, 802.7798));
					}
					if (StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) > 7550 && StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) < 18250)
					{
						Flightor.MoveTo(new WoWPoint(5638.103, 2082.158, 803.5102));
					}
					if (StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) > 1100 && StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) < 7550) 
					{
						Flightor.MoveTo(new WoWPoint(5616.018, 2030.401, 798.2736));
					}
					if (StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) > 1 && StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) < 1100) 
					{
						Flightor.MoveTo(new WoWPoint(5592.38, 2010.549, 798.1951));
					}
					if (StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) < 5) 
					{
						Navigator.PlayerMover.MoveTowards(new WoWPoint(5581.248, 2000.396, 798.0414));
					}
				await Coroutine.Yield();
				}

				// Universal navigation.
				else {
					if (StyxWoW.Me.Location.DistanceSqr(StyxWoW.Me.CorpsePoint) > 5f*5f)
					{
					  //Flightor handles calling Navigator internally when it can't fly.
						Flightor.MoveTo(StyxWoW.Me.CorpsePoint);
					}
					else
					{
						var instancePoI = ObjectManager.GetObjectsOfType<WoWGameObject>().FirstOrDefault(o => o.SubType == WoWGameObjectType.DungeonDifficulty);
						if (instancePoI.IsValid) 
						{
							Logging.Write(System.Windows.Media.Colors.Yellow, "[Azyul Death Handler]: Instance portal detected, moving towards instance object location.");
							StyxWoW.Me.SetFacing(instancePoI.Location);
							await Coroutine.Wait(5000, () => StyxWoW.Me.IsSafelyFacing(instancePoI, 10f));
							Lua.DoString("ToggleAutoRun();");
							await Coroutine.Wait(3000, () => StyxWoW.Me.IsInInstance);
						}
						else //Older dungeons can't be identified but typically place the CorsePoint on the instance load trigger.
						{
							Logging.Write(System.Windows.Media.Colors.Yellow, "[Azyul Death Handler]: Instance portal not detected, moving towards corpse point.");
							StyxWoW.Me.SetFacing(StyxWoW.Me.CorpsePoint);
							await Coroutine.Wait(5000, () => StyxWoW.Me.IsFacing(StyxWoW.Me.CorpsePoint)); // Could use a degree check for WoWPoint. :P
							Navigator.PlayerMover.MoveTowards(StyxWoW.Me.CorpsePoint);
							await Coroutine.Wait(3000, () => StyxWoW.Me.IsInInstance);
						}
					}
					await Coroutine.Yield();
				}
			}

			return true;
		}

		public override void Pulse()
		{
		}
	}
}